<?php

namespace Drupal\cmlstarter_demo\Plugin\migrate\source;

use Drupal\cmlstarter_demo\Utility\MigrationsSourceBase;

/**
 * Source for CSV.
 *
 * @MigrateSource(
 *   id = "s_product"
 * )
 */
class StoreProduct extends MigrationsSourceBase {
  public $src = 'product';

  /**
   * {@inheritdoc}
   */
  public function getRows() {
    $rows = [];
    if ($source = $this->getContent($this->src)) {
      foreach ($source as $key => $row) {
        $id = $row['uuid'];
        $variations = [];
        if (!empty($row['variations'])) {
          foreach ($row['variations'] as $k => $v) {
            $variations["{$id}:{$k}"] = "{$id}:{$k}";
          }
        }
        $rows[$id] = [
          'id' => $id,
          'uuid' => "{$id}-0000-0000-0000-000000000000",
          'type' => $row['type'],
          'stores' => $row['stores'],
          'status' => $row['status'],
          'created' => $row['created'],
          'changed' => $row['changed'],
          'title' => $row['title'],
          'field_title' => $row['field_title'],
          'field_catalog' => $row['field_catalog'],
          'field_tx_brand' => $row['field_tx_brand'],
          'field_tx_options' => $this->ensureTerm($row['field_tx_options']),
          'field_short' => $row['field_short'],
          'variations' => $row['variations'] ,
          'field_image' => $this->ensureFiles($row['field_image'], 'product'),
          'field_gallery' => $this->ensureFiles($row['field_gallery'], 'product'),
          'field_attach' => $this->ensureFiles($row['field_attach'], 'product'),
          'field_paragraph' => $row['field_paragraph'],
          'field_rf_product' => $row['field_rf_product'],
          'body' => [
            'value' => str_replace("\n", " ", $row['body']),
            'format' => "wysiwyg",
          ],
        ];
        $rows[$id]['variations'] = array_shift($variations);
        //$rows[$id]['field_paragraph'] = FALSE;
      }
    }
    $this->debug = TRUE;
    return $rows;
  }

  /**
   * {@inheritdoc}
   */
  public function count($refresh = FALSE) {
    $source = $this->getContent($this->src, TRUE);
    return count($source);
  }

}
